<?
include( '../include/config.inc.php' );



if ( $_user_status['current_run'] )
{

	$f = fopen( '../include/'.INITIAL_T_PROFILE_FILE, 'r' );

	if ( $_user_status['run'][ $_user_status['current_run']  ]['atmosphere'] )
		$_atmosphere_data = $_user_status['run'][ $_user_status['current_run']  ]['atmosphere'];
	else
		$_atmosphere_data = $config['atmosphere']['default'];



	while( $line = fgets( $f, 1024 ))
	{
		list( $layer, $T ) = explode( ',', rtrim( $line ) );

		$a_initial_temperatures[$layer] = $T;
	}
?>

<div>
 <form id="_form_atmosphere">
 <input type="hidden" name="actiontype" value="Save_Atmosphere"/>
 <h2>Configure Atmosphere - <?=$_user_status['run'][ $_user_status['current_run']  ]['title']?></h2>
 <div>
  <h3><?=$config['ghg']['wet']['H20']['description']?></h3>
 </div>
 <div>
  <table>
    <tr>
     <th>Layer</th>
     <th>Pressure Range</th>
     <th>Temperature</th>
     <th>Relative Humidity</th>
    </tr>
    <tr>
     <td>
      Surface
     </td>
     <td>
      <?=TOTAL_ATMOSPHERE?> hPa
     </td>
     <td>
       <?=$a_initial_temperatures[0]?> K
     </td>
    </tr>
<?
	
	for( $j=0; $j<NO_LAYERS; $j++ )
	{
?>
   <tr>
     <td>
      <?=$j?>
     </td>
     <td>
      <?=(TOTAL_ATMOSPHERE - ($j*TOTAL_ATMOSPHERE/NO_LAYERS))?> - <?=( TOTAL_ATMOSPHERE -(($j+1)*TOTAL_ATMOSPHERE/NO_LAYERS))?> hPa
     </td>
     <td>
       <?=(($T = $Model->layers[$j]->T)?$T:$a_initial_temperatures[$j+1])?> K
     </td>
     <td>
       <input type="text" name="relhumidity[<?=$j?>]" value="<?=$_atmosphere_data[relhumidity][$j]?>" style="width: 50px"/> %
     </td>
    </tr>
<?
	}
	
?>
    <tr>
     <td style="vertical-align:text-top"><input type="checkbox" value="1" name="vapour_feedback" <?if( $_atmosphere_data['vapour_feedback'] ){ echo 'checked="checked"'; }?> /></td>
     <td colspan="3" style="vertical-align:text-top">
       Adjust vapour levels with deduced temperatures<br/>
       This allows the model to simulate feedback effect of H20 vapour pressure changes from temperature changes by keeping relative humidity fixed.
       Otherwise, the initial vapour pressures will be assumed to be fixed.	
     </td>   
    </tr> 
  </table>
 </div>
 <div>
  <h3>Clouds</h3>
 </div>
 <div>
    <table>
      <tr>
        <td colspan="2"></td>
        <td>
          Clouds at Layer
        </td>
        <td>
          <select name="cloudLayer" style="width: 50px">
<?
	
	for( $j=0; $j<NO_LAYERS; $j++ )
	{
?>
           <option value="<?=$j?>" <?if( $_atmosphere_data['cloudLayer'] == $j ){ echo 'selected="selected"'; }?>><?=$j?></option>
<?
	}
?>
          </select> 
        </td>
      </tr>
      <tr>
        <td colspan="2"></td>  
        <td>
          Percentage Cover
        </td>
        <td>
           <input type="text" name="cloudCover" value="<?=$_atmosphere_data['cloudCover']?>" style="width: 50px"/> %
        </td>
       </tr>
       <tr>
         <td colspan="2">
           <strong>Shortwave(Solar) Properties</strong>
         </td>
         <td>
            Albedo
         </td>
         <td>
           <input type="text" name="cloudShortWave[albedo]" class="cloudShortWave_parameters" value="<?=$_atmosphere_data['cloudShortWave']['albedo']?>" style="width: 50px"/> %
         </td>
       </tr>
       <tr>
         <td colspan="2"></td>
         <td>
            Absorption
         </td>
          <td>
           <input type="text" name="cloudShortWave[absorption]" class="cloudShortWave_parameters" value="<?=$_atmosphere_data['cloudShortWave']['absorption']?>" style="width: 50px"/> %
         </td>
        </tr>
        <tr>
         <td colspan="2"></td>
         <td>
            Passthru
         </td> 
         <td>
           <input type="text" name="cloudShortWave[passthru]" class="cloudShortWave_parameters" value="<?=$_atmosphere_data['cloudShortWave']['passthru']?>" style="width: 50px"/> %
         </td>
       </tr>
       <tr>
         <td colspan="2">
           <strong>Longwave(Infrared) Properties</strong>
         </td>
         <td>
            Albedo
         </td>
         <td>
           <input type="text" name="cloudLongWave[albedo]" class="cloudLongWave_parameters" value="<?=$_atmosphere_data['cloudLongWave']['albedo']?>" style="width: 50px"/> %
         </td>
       </tr>
       <tr>
         <td colspan="2"></td>
         <td>
            Absorption
         </td>
          <td>
           <input type="text" name="cloudLongWave[absorption]" class="cloudLongWave_parameters" value="<?=$_atmosphere_data['cloudLongWave']['absorption']?>" style="width: 50px"/> %
         </td>
        </tr>
        <tr>
         <td colspan="2"></td>
         <td>
            Passthru
         </td> 
         <td>
           <input type="text" name="cloudLongWave[passthru]" class="cloudLongWave_parameters" value="<?=$_atmosphere_data['cloudLongWave']['passthru']?>" style="width: 50px"/> %
         </td>
       </tr>
     </table>
 </div> 
 <div>
  <h3>Dry Greenhouse Gasses</h3>
 </div>
 <div>
    <table>
<?
while( list( $gas, ) = each( $config['ghg']['dry'] ) )
{
?>
      <tr>
         <td><strong><?=$config['ghg']['dry'][$gas]['description']?></strong></td>
         <td>Current Level </td>
         <td><?=$config['ghg']['dry'][$gas]['concentration']?> <?=$config['ghg']['dry'][$gas]['units']?></td>
      </tr>
      <tr>
         <td style="text-align: right">Enter Scenario</td>
         <td><input type="text" name="dryGas[<?=$gas?>][scenario]" value="<?=$_atmosphere_data[dryGas][$gas][scenario]?>" style="width: 50px" onkeyup="$('#dryGas_<?=$gas?>_scenario').html( String( Math.round( 100 * Number(this.value) * <?=$config['ghg']['dry'][$gas]['concentration']?>)/100 ) )"/></td>
         <td><span id="dryGas_<?=$gas?>_scenario"><?=$config['ghg']['dry'][$gas]['concentration']?></span> <?=$config['ghg']['dry'][$gas]['units']?></td>
      </tr>
      <tr><td>&nbsp;</td></tr>		
<?
}
?>  
    </table>
 </div>
 <div>
 <h3>Convection</h3>
 Convection is modelled as an energy flux that is proportional to the temperature gradient less the adiabatic lapse rates squared. (NB: gradients are negative)<br/>
 <p style="font-size: 11px; font-style: italic">
 Dry Convection = C<sub>d</sub>( <sup>&Delta;T</sup>/<sub>&Delta;P</sub> - L<sub>d</sub> / <sub>&#254; g</sub> )<sup>2</sup>  &nbsp; Providing: ( <sup>&Delta;T</sup>/<sub>&Delta;P</sub> - L<sub>d</sub> / <sub>&#254; g</sub> ) < 0<br/>
 Wet Convection = C<sub>w</sub>( <sup>&Delta;T</sup>/<sub>&Delta;P</sub> - L<sub>w</sub> / <sub>&#254; g</sub> )<sup>2</sup>  &nbsp; Providing: ( <sup>&Delta;T</sup>/<sub>&Delta;P</sub> - L<sub>w</sub> / <sub>&#254; g</sub> ) < 0<br/>
 C<sub>d</sub> - Coefficient of Dry Convection (Wm<sup>-2</sup> K&deg;<sup>-2</sup>hPa<sup>2</sup>)<br/>
 C<sub>w</sub> - Coefficient of Wet Convection  (Wm<sup>-2</sup> K&deg;<sup>-2</sup>hPa<sup>2</sup>)<br/>
 L<sub>d</sub> - Dry Adiabatic Lapse rate (K&deg;m<sup>-1</sup>)<br/>
 L<sub>w</sub> - Wet Adiabatic Lapse rate (K&deg;m<sup>-1</sup>)<br/>
 &#254; - Air Density (Kg m<sup>-3</sup>)<br/>
 g - Acceleraton from gravity (ms<sup>-2)</sup>
 </p>	
 </div>
 <div>
      <table>
        <tr>
          <td><input type="checkbox" name="add_dry_convection" value="1" <?if( $_atmosphere_data['add_dry_convection'] ){ echo 'checked="checked"'; }?>/></td>
          <td>Simulate Dry Convection &nbsp; &nbsp;</td> 
          <td>Set Coefficient:</td>
          <td><input type="text" name="coefficient_of_dry_convection" value="<?=$_atmosphere_data['coefficient_of_dry_convection']?>"/> <span style="font-size: 11px; font-style: italic">(Wm<sup>-2</sup> K&deg;<sup>-2</sup>hPa<sup>2</sup>)</span> </td>
        </tr>
        <tr>
          <td><input type="checkbox" name="add_wet_convection" <?if( $_atmosphere_data['add_wet_convection'] ){ echo 'checked="checked"'; }?>/></td>
          <td>Simulate Wet Convection &nbsp; &nbsp;</td>
          <td>Set Coefficient:</td>
          <td><input type="text" name="coefficient_of_wet_convection" value="<?=$_atmosphere_data['coefficient_of_wet_convection']?>"/> <span style="font-size: 11px; font-style: italic">(Wm<sup>-2</sup> K&deg;<sup>-2</sup>hPa<sup>2</sup>)</span></td> 
        </tr>
      </table>
 </div> 
 <div>
   <p><input type="button" id="_bt_atmosphere" value="Save Atmosphere Configuration"  <?if( $bool_read_only ){ echo 'disabled="disabled"'; }?>/></p>
 </div>
 </form> 
</div>
<script type="text/javascript" src="js/atmosphere.js"></script> 
<?
}
else
{
?>
<h2>Configure Atmosphere</h2>
Please run a Simulation First
<?
}
?>
