<?
require_once( '../include/config.inc.php' );

?>
<h2>Temperature Profiles - Table</h2>
<?
if( is_array($_user_status['run']) )
{
?>
<table class="tResults" cellpadding="0" cellspacing="0">
  <tr>
    <th></th>
<?
	while( list( $k,  ) = each( $_user_status['run'] ) )	
	{
		if ( !isset($_base_run)  )
			$_base_run = $k;
?>
     <th colspan="2"><?=$_user_status['run'][$k]['title']?></th>
<?
	}
?>
  </tr>
  <tr>
    <th></th>
<?
	reset( $_user_status['run'] );	

	while( list( $k,  ) = each( $_user_status['run'] ) )	
	{
		if ( !$_user_status['run'][$k]['result'] )
				continue;

		if ( !isset($_base_run)  )
			$_base_run = $k;
?>
     <td>T&deg;(K)</td>
     <td>&Delta;T&deg;</td>
<?
	}
?>
  </tr>
<?
	for( $j=0; $j<=NO_LAYERS; $j++ )
	{
?>
   <tr>
     <td>
<?
		if ( $j == 0 )
		{
?>
	  Surface
<?
		}
		else
		{
?>	
          <?=(TOTAL_ATMOSPHERE - (($j-0.5)*TOTAL_ATMOSPHERE/NO_LAYERS))?> hPa
<?
		}
?>
     </td>
<?
		reset( $_user_status['run'] );	

		while( list( $k,  ) = each( $_user_status['run'] ) )
		{
			if ( !$_user_status['run'][$k]['result'] )
				continue;
?>
      <td>
        <?=round( $_user_status['run'][$k]['result'][ ($j==0)?'s':($j-1) ], 1 )?>
      </td>
      <td>
        <?=round( ($_user_status['run'][$k]['result'][ ($j==0)?'s':($j-1) ] - $_user_status['run'][$_base_run]['result'][ ($j==0)?'s':($j-1) ]), 1 )?> 
      </td>
<?
		}
	}
?>
  </tr>
</table>
<h2>Temperature Profiles - Graph</h2>
<embed src="include/process.php?actiontype=getSVGTemperatures" width="700" height="800"
type="image/svg+xml" pluginspage="http://www.adobe.com/svg/viewer/install/"/>
<?
}
else
{
?>
Please run a simulation first
<?
}
?>
