<?
include( 'config.inc.php' );



if( $_POST['actiontype'] == 'Save_Atmosphere' )
{
	if ( $bool_read_only ){
		echo json_encode( array( 'success'=>0 ) );
		exit;	
	}

	if ( isset( $_user_status['run'][ $_user_status['current_run'] ]['status'] ))
		unset( $_user_status['run'][ $_user_status['current_run'] ]['status'] );


	$_user_status['run'][ $_user_status['current_run']  ]['atmosphere'] = $_POST;
	saveStatus();

	unlink( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_user_status['current_run'].'/radiation.svg' );
	unlink( '../'.USER_SPACE.'/'.$user_id.'/radiation.svg' );

	for( $i=0; $i<NO_LAYERS; $i++ )
	{
		if ( file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_user_status['current_run'].'/absorptions-'.$i.'.svg' ))
		{
			unlink( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_user_status['current_run'].'/absorptions-'.$i.'.svg'  );
		}
	}

	echo json_encode( array( 'success'=>1 ) );
	exit;
}


if( $_POST['actiontype'] == 'Create_Simulation' )
{
	session_start();

	if ( $_SESSION['_user_status'] )
	{
		$_SESSION['_user_status'] = NULL;
		$_SESSION['user_id'] = NULL;	
		
	}

	session_write_close();

	if ( $bool_read_only ){
		echo json_encode( array( 'success'=>0 ) );
		exit;	
	}


	if ( isset( $_user_status['noruns'] ))
		$_user_status['noruns']++;
	else
		$_user_status['noruns'] = 1;

	$_user_status['current_run'] = $_user_status['noruns'];

	$_user_status['run'][ $_user_status['current_run']  ]['title'] = $_POST['_decription'];

	$Model = new Model();	
	$Model->title = $_POST['_decription'];

	saveStatus( $Model );

	echo json_encode( array( 'success'=>1 ) );
	exit;
}


if ( $_GET['actiontype'] == 'selectsimulation' )
{

	$_user_status['current_run'] = $_GET['value'];

	saveStatus();
	exit;

}

if ( $_GET['actiontype'] == 'deleteRun' )
{
	if ( $bool_read_only ){
		echo json_encode( array( 'success'=>0 ) );
		exit;	
	}

	$_run = $_GET['value'];

	unset( $_user_status['run'][ $_run ] );
	deleteDirectory(  '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run );

	if ( $_user_status['current_run'] == $_run )
	{
		list( $k, ) = each( $_user_status['run'] );
		$_user_status['current_run'] = $k;
	}
	saveStatus();

}

if ( $_GET['actiontype'] == 'getCurrentRun' )
{
	echo json_encode( array( 'title'=> $_user_status['run'][ $_user_status['current_run']  ]['title'], 'run' => $_user_status['current_run'] ) );
	exit;

}


if ( $_GET['actiontype'] == 'monitor' )
{

	if ( $bool_read_only ){
		echo json_encode( array( 'success'=>0 ) );
		exit;	
	}

	$_run = $_GET['run'];

	if( !file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/output.txt' ) )
		die( json_encode( array( 'messages'=>'Waiting....', 'fraction'=>0 )  ) );	

	

	$a = file( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/output.txt' );
	$int_no_lines = sizeof( $a );
	$d = '';

	$messages = '';
	
	for( $k=$int_no_lines-25; $k<$int_no_lines; $k++ )
	{
		$messages .= $d.rtrim( $a[$k] );
		$d = '<br/>';
	}


	if( !file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/status.json' ) )
		die( json_encode( array( 'messages'=>$messages, 'fraction'=>0 )  ) );	

	$status = json_decode( file_get_contents( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/status.json' ));


	$status->description = $_user_status['run'][ $_user_status['current_run']  ]['title'].' - '.$status->description;
	$status->messages = $messages;

	

	echo json_encode( $status );
	exit;
}

if ( $_GET['actiontype'] == 'simulate' )
{
	if ( $bool_read_only ){
		echo json_encode( array( 'success'=>0 ) );
		exit;	
	}

	$_run = $_GET['run'];

	$Model = getCurrentModel( $_run );
	$Model->verbose = 0;

	$Model->outputFile = '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/output.txt';
	$Model->outputStatusFile = '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/status.json';


	$atmosphere = $_user_status['run'][ $_run  ]['atmosphere'];

	switch ( $_user_status['run'][ $_run ]['status']['step'] )
	{
	   
				
	    case NULL:


		//build H2O decay file
		
		unset( $Model->resultSet );

		if ( file_exists(  '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/output.txt' ) )
			unlink( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/output.txt' );

		if ( file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/status.json' ) )
			unlink( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/status.json' );

		$reference_vapour_pressure = $Model->getSaturationVapourPressure( $config['ghg']['wet']['H20']['referenceT'] );

		$f = fopen( INITIAL_T_PROFILE_FILE, 'r' );

		while( $line = fgets( $f, 1024 ) )
		{
			if ( trim( $line ) )
			{	
				list( $layer, $T ) = explode( ',', rtrim( $line ) );
				$_result[ $layer ] = $T;
			}
		}

		fclose( $f );

		$f = fopen( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/H2O-decay.txt', 'w' );
		$n = '';


		for( $k=0; $k<sizeof($_result); $k++ )
		{

			if ( $k > 0 )
				$_decay = ($atmosphere['relhumidity'][$k-1]/$config['ghg']['wet']['H20']['referenceH']) * ($Model->getSaturationVapourPressure( $_result[$k] ) / $reference_vapour_pressure );
			else
				$_decay = ($atmosphere['relhumidity'][$k]/$config['ghg']['wet']['H20']['referenceH']) * ($Model->getSaturationVapourPressure( $_result[$k] ) / $reference_vapour_pressure );

			fwrite( $f, $n.$k.','.$_decay );

			$n = "\n";
		}

		fclose( $f );

		//load atmosphere into model

		$_gasses = array();

		//H20
		$_gasses[0] = $config['ghg']['wet']['H20']['parameters'];
		$_gasses[0]['decay'] = '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/H2O-decay.txt';

		$index = 1;

		while( list( $gas,  ) = each($config['ghg']['dry']) )
		{
			$_gasses[$index] = $config['ghg']['dry'][ $gas ]['parameters'];
			$_gasses[$index]['scenario'] = $atmosphere['dryGas'][$gas]['scenario'];

			$index++;
		}

		

		$Model->loadAbsorptionSpectrums(  $_gasses  );
		
		$_user_status['run'][ $_run ]['status']['step'] = 1;

		saveStatus( $Model, $_run );
	

	   case "1" :

						
		$clouds=array( 'base'=>$atmosphere['cloudLayer'],
					'top'=>$atmosphere['cloudLayer'], 
					'cover'=>($atmosphere['cloudCover']/100), 
					'shortwave'=>array(
						'albedo'=>($atmosphere['cloudShortWave']['albedo']/100),
						'absorption'=>($atmosphere['cloudShortWave']['absorption']/100),
						'passthru'=>($atmosphere['cloudShortWave']['passthru']/100)), 

					'longwave'=>array(
						'albedo'=>($atmosphere['cloudLongWave']['albedo']/100),
						'absorption'=>($atmosphere['cloudLongWave']['absorption']/100),
						'passthru'=>($atmosphere['cloudLongWave']['passthru']/100)  ) 
					); 

		$Model->add_dry_convection = $atmosphere['add_dry_convection'];
		$Model->add_wet_convection = $atmosphere['add_wet_convection'];

		$Model->coefficient_of_wet_convection = $atmosphere['coefficient_of_wet_convection'];
		$Model->coefficient_of_dry_convection = $atmosphere['coefficient_of_dry_convection'];

	
		$Model->setClouds( $clouds );
		$Model->createLayers( NO_LAYERS );

		$Model->purgeGasData();				

		$_user_status['run'][ $_run ]['status']['step'] = 2;
		saveStatus( $Model, $_run );

	
	
	   case "2" :
			
		if ( !($_start_layer = $_user_status['run'][ $_run ]['status']['layer']) )
			$_start_layer = 0;	

		if ( ($_start_layer == 0) && $atmosphere['vapour_feedback'] && (sizeof($Model->resultSet) > 1) )
		{
			//build H2O decay file
		
			$reference_vapour_pressure = $Model->getSaturationVapourPressure( $config['ghg']['wet']['H20']['referenceT'] );

			$f = fopen( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/H2O-decay.txt', 'w' );
			$n = '';

			$_result = $Model->resultSet[ sizeof( $Model->resultSet ) - 1 ]['values'];


			for( $k=0; $k<sizeof($_result); $k++ )
			{

				if ( $k > 0 )
					$_decay = ($atmosphere['relhumidity'][$k-1]/$config['ghg']['wet']['H20']['referenceH']) * ($Model->getSaturationVapourPressure( $_result[$k] ) / $reference_vapour_pressure );
				else
					$_decay = ($atmosphere['relhumidity'][$k]/$config['ghg']['wet']['H20']['referenceH']) * ($Model->getSaturationVapourPressure( $_result[$k] ) / $reference_vapour_pressure );

				fwrite( $f, $n.$k.','.$_decay );

				$n = "\n";
			}

			fclose( $f );

			//load atmosphere into model

			$_gasses = array();

			//H20
			$_gasses[0] = $config['ghg']['wet']['H20']['parameters'];
			$_gasses[0]['decay'] = '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/H2O-decay.txt';

			$index = 1;

			reset( $config['ghg']['dry'] );

			while( list( $gas,  ) = each($config['ghg']['dry']) )
			{
				$_gasses[$index] = $config['ghg']['dry'][ $gas ]['parameters'];
				$_gasses[$index]['scenario'] = $atmosphere['dryGas'][$gas]['scenario'];

				$index++;
			}

			$Model->loadAbsorptionSpectrums(  $_gasses  );
			$Model->createLayers( NO_LAYERS );

			$Model->purgeGasData();				

			$_user_status['run'][ $_run ]['status']['step'] = 2;
			saveStatus( $Model, $_run );

		}		

		for( $k = $_start_layer; $k<=NO_LAYERS; $k++ )
		{

			$Model->create_Mattrix($k);
			$_user_status['run'][ $_run ]['status']['layer'] = $k+1; 
			saveStatus( $Model, $_run );
		}

		$result = $Model->solveMattrix();
		

		if ( ($_deviation = $Model->getDeviation()) < TOLERANCE )
		{
			$_user_status['run'][ $_run ]['status']['step'] = 3;
			$_user_status['run'][ $_run ]['result'] = $result;
			saveStatus( $Model, $_run );

			echo json_encode( array( 'status'=>'finished' ) );
			exit;
		}
		else
		{
			unset( $_user_status['run'][ $_run ]['status']['layer'] );

			$Model->bounceCorrection();

			saveStatus( $Model, $_run );
			echo json_encode( array( 'status'=>'continue' ) );
			exit;
			
		}

	   case "3" :	    

		echo json_encode( array( 'status'=>'finished' ) );
		exit;


	   break;

	}

	
	echo json_encode( array( 'status'=>'continue' ) );
	exit;
}

if ( $_GET['actiontype'] == 'getSVGTemperatures' )
{
	$maxT = 0;
	$minT = 500;

	define( X_WIDTH, 550 );
	define( _MARGIN, 40 );

	define( Y_HEIGHT, 550 );
	

	while( list( $k,  ) = each( $_user_status['run'] ) )	
	{
		if ( !$_user_status['run'][$k]['result'] )
			continue;

		for( $j=0; $j<=NO_LAYERS; $j++ )
		{
			$t = $_user_status['run'][$k]['result'][ ($j==0)?'s':($j-1) ];

			$minT = min( $minT, $t );
			$maxT = max( $maxT, $t  );
		}

	}

	if ( !$maxT )
	{
		$maxT = 320;
		$minT = 200;

	}

	reset( $_user_status['run'] );

	$_min_x = floor( $minT/10 ) * 10;
	$_max_x = ceil( $maxT/10 ) * 10;

	$_span_x = $_max_x - $_min_x;
	$_int_x = $_span_x/10;


	


	Header( "Content-type: image/svg+xml" );

	echo '<'.'?xml version="1.0" standalone="no"'.'?>';
?>  
        
        <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> 
	<svg width="100%" height="100%" version="1.1" xmlns="http://www.w3.org/2000/svg">

        <line x1="<?=_MARGIN?>" y1="<?=_MARGIN?>"   x2="<?=_MARGIN?>"  y2="<?=X_WIDTH+_MARGIN?>" style="stroke: #000000; stroke-width:2;"/>
 	<line x1="<?=_MARGIN?>" y1="<?=Y_HEIGHT+_MARGIN?>"  x2="<?=X_WIDTH+_MARGIN?>" y2="<?=Y_HEIGHT+_MARGIN?>" style="stroke: #000000; stroke-width:2;"/>	

<?	
	$i=0;

	for( $t=0; $t<=$_int_x; $t++ )
	{
		
		$_pos_x = _MARGIN + ( $t * X_WIDTH /$_int_x ) ;
?>		
        <line x1="<?=$_pos_x?>" y1="<?=Y_HEIGHT+_MARGIN?>"  x2="<?=$_pos_x?>" y2="<?=Y_HEIGHT+_MARGIN+5?>" style="stroke: #000000; stroke-width:2;"/>
        <text x="<?=$_pos_x-5?>" y="<?=Y_HEIGHT+_MARGIN+15?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" ><?=$_min_x+($t*10)?></text>
<?
		$i++;	
	}
?>
	<text x="<?=_MARGIN + X_WIDTH + 25?>" y="<?=Y_HEIGHT+_MARGIN+15?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 12px;" >T &#176; Kelvin</text>
<?
	for( $l=1; $l<=NO_LAYERS; $l++ )
	{
		$_pos_y = Y_HEIGHT+_MARGIN - (($l-0.5)*Y_HEIGHT/10);
?>	
	<line x1="<?=_MARGIN?>" y1="<?=$_pos_y?>"  x2="<?=_MARGIN+4?>" y2="<?=$_pos_y?>" style="stroke: #000000; stroke-width:2;"/>	
        <text x="<?=_MARGIN-20?>" y="<?=$_pos_y+4?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;"><?=(TOTAL_ATMOSPHERE - (($l-0.5)*TOTAL_ATMOSPHERE/NO_LAYERS))?></text>
<?	
	}
?>	
         <text x="<?=_MARGIN-20?>" y="<?=_MARGIN-20?>" style="stroke:#000000; font-family:Arial; font-size: 12px;" >height HPa</text> 
<?
	$i=0;

	while( list( $k,  ) = each( $_user_status['run'] ) )	
	{
	    
	   if ( !$_user_status['run'][$k]['result'] )
			continue;

	   $circles = "";	

	    echo '<path style="stroke: '.getColour( $k-1 ).'; stroke-width:1; fill:none;" d="';

		$ML = "\nM";

		for( $j=0; $j<=NO_LAYERS; $j++ )
		{
			$t = $_user_status['run'][$k]['result'][ ($j==0)?'s':($j-1) ];

			$_pos_x = _MARGIN + (($t - $_min_x) * X_WIDTH/ $_span_x	);
			
			if ( $j == 0 )
				$_pos_y = Y_HEIGHT + _MARGIN; 		
			else
				$_pos_y = Y_HEIGHT + _MARGIN - ( ($j-0.5) * Y_HEIGHT/NO_LAYERS  ); 

			
			echo $ML.$_pos_x.','.$_pos_y;
			$ML = "\nL";

			$circles .= '<circle cx="'.$_pos_x.'" cy="'.$_pos_y.'" r="2" stroke="'.getColour( $k-1 ).'" stroke-width="2" fill="'.getColour( $k-1 ).'"/>'."\n";


		}

		echo '"/>';

		echo $circles;
?>
                <line x1="<?=_MARGIN?>" y1="<?=( Y_HEIGHT + _MARGIN + 60 +( $i*20 ))?>"  x2="<?=_MARGIN+60?>" y2="<?=( Y_HEIGHT + _MARGIN + 60 +( $i*20 ))?>" style="stroke: <?=getColour( $k-1 )?>; stroke-width:2;"/>
		<text x="<?=_MARGIN+80?>" y="<?=( Y_HEIGHT + _MARGIN + 60 +( $i*20 ))?>" style="stroke: <?=getColour( $k-1 )?>; font-family:Arial; font-size: 10px;" ><?=htmlentities($_user_status['run'][$k]['title'])?></text> 
<?

		$i++;	

	}


?>
        </svg>
<?

}

if ( $_GET['actiontype'] == 'getSVGAbsorptions' )
{
	for( $i=0; $i<NO_LAYERS; $i++ )
	{
		if ( !file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_user_status['current_run'].'/absorptions-'.$i.'.svg' ))
		{
			$bool_build = true;
			break;
		}
	}

	if ( $bool_build )
	{	
	
		$Model = getCurrentModel();

		for( $i=0; $i<NO_LAYERS; $i++ )
		{
			if ( !file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_user_status['current_run'].'/absorptions-'.$i.'.svg' ) )
			{
				$svg_file = '../'.USER_SPACE.'/'.$user_id.'/run_'.$_user_status['current_run'].'/absorptions-'.$i.'.svg';
				$Model->layers[$i]->createAbsorptionGraph( $svg_file, $Model->layers['s']->T );
			}
		}
	}

	echo json_encode( array('success'=>1) );
}

if ( $_GET['actiontype'] == 'getRadiation' )
{
	if( !file_exists('../'.USER_SPACE.'/'.$user_id.'/radiation.svg'	) )
	{	
		$bool_build = true;
	}
	else
	{


		while( list( $k,  ) = each( $_user_status['run'] ) )	
		{
			if ( !$_user_status['run'][$k]['result'] )
				continue;

			if ( !file_exists( '../'.USER_SPACE.'/'.$user_id.'/run_'.$k.'/radiation.svg' ) )
			{
				$bool_build = true;
				break;
			}	

		}

		reset( $_user_status['run'] );
	}

	if ( $bool_build )
	{

		$_spectrums = array();

		while(  list( $_run,  ) = each( $_user_status['run'] ) )	
		{
			if ( !$_user_status['run'][$_run]['result'] )
				continue;

			


				$Model = getCurrentModel( $_run );
				$spectrum = $Model->createOutgoingSpectrum();
				
				$_spectrums[] = array( 'spectrum'=> $spectrum, 'title'=>$_user_status['run'][$_run]['title'] );

				$maxE = $Model->surfacealbedo*Model::getEFromPlanksEquations( WIENS_CONSTANT_B * pow(10,6) / $Model->layers['s']->T, $Model->layers['s']->T );

				$_maxE = max( $_maxE, $maxE );

				define('X_WIDTH_SPECTRUM', 750 );


				$_svg =  '<'.'?xml version="1.0" standalone="no"'.'?>'."\n";
				$_svg .= '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">'."\n"; 
				$_svg .= '<svg width="100%" height="100%" version="1.1" xmlns="http://www.w3.org/2000/svg">'."\n";

				$_svg .=	'<line x1="10" y1="20"   x2="10"  y2="260" style="stroke: #000000; stroke-width:2;"/>'."\n";
			 	$_svg .=	'<line x1="10" y1="260"  x2="'.(X_WIDTH_SPECTRUM+10).'" y2="260" style="stroke: #000000; stroke-width:2;"/>'."\n";	
				$_svg .=	'<path d="'."\n";

				$_x_scale = X_WIDTH_SPECTRUM / $spectrum[ sizeof( $spectrum )-1 ]['y'];
				$_y_scale = 240/$maxE;

				$_svg .=    'M'.(($spectrum[0]['y']*$_x_scale)+10).','.( 260 - ($spectrum[0]['e']*$_y_scale))."\n";

				for( $k=1; $k<sizeof( $spectrum ); $k++ )
				{
					$_svg .=    'L'.(($spectrum[$k]['y']*$_x_scale)+10).','.( 260 - ($spectrum[$k]['e']*$_y_scale))."\n";
					//$_svg .=    'L'.(($spectrum[$k]['y']*$_x_scale)+10).','.( 250 - (Model::getEFromPlanksEquations( $spectrum[$k]['y'], $Model->layers['s']->T )*$_y_scale))."\n";
				}

				$_svg .= '"'."\n";
		
				$_svg .= 'style="stroke: #0B0B3B; stroke-width:1; fill:none;"/>'."\n";


				$_svg .=	'<path d="'."\n";
				$_svg .=    'M'.(($spectrum[0]['y']*$_x_scale)+10).','.( 260 - ($Model->surfacealbedo*Model::getEFromPlanksEquations( $spectrum[0]['y'], $Model->layers['s']->T )*$_y_scale))."\n";

				for( $k=1; $k<sizeof( $spectrum ); $k++ )
				{
					$_svg .=    'L'.(($spectrum[$k]['y']*$_x_scale)+10).','.( 260 - ($Model->surfacealbedo*Model::getEFromPlanksEquations( $spectrum[$k]['y'], $Model->layers['s']->T )*$_y_scale))."\n";
				}

				$_svg .= '"'."\n";
		
				$_svg .= 'style="stroke: #FF0000; stroke-width:1; fill:none;"/>'."\n";


				$_svg .= '<text x="10" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >0</text>'."\n";
				$_svg .= '<text x="'.((X_WIDTH_SPECTRUM/5)+8).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >20&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (20*$_x_scale)).'" y1="260"   x2="'.(10 + (20*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.((2*X_WIDTH_SPECTRUM/5)+6).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >40&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (40*$_x_scale)).'" y1="260"   x2="'.(10 + (40*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.((3*X_WIDTH_SPECTRUM/5)+14).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >60&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (60*$_x_scale)).'" y1="260"   x2="'.(10 + (60*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.((4*X_WIDTH_SPECTRUM/5)+2).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >80&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (80*$_x_scale)).'" y1="260"   x2="'.(10 + (80*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.( X_WIDTH_SPECTRUM ).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >100&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (100*$_x_scale)).'" y1="260"   x2="'.(10 + (100*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";

				$_svg .= '<text x="10" y="12" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >'.round($maxE,1).' W/m&#179;</text>'."\n";

				$_svg .= '<line x1="10" y1="285"   x2="40"  y2="285" style="stroke: #0B0B3B; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="50" y="289" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >Modelled Outgoing Longwave Spectrum</text>'."\n";

				$_svg .= '<line x1="10" y1="300"   x2="40"  y2="300" style="stroke: #FF0000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="50" y="304" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >Modelled Surface Spectrum ( '.round($Model->layers['s']->T,1).'&#176; Kelvin )</text>'."\n";

				$_svg .= '</svg>';

				file_put_contents( '../'.USER_SPACE.'/'.$user_id.'/run_'.$_run.'/radiation.svg', $_svg );

			
		}

		if( sizeof( $_spectrums ) )
		{

				$_svg =  '<'.'?xml version="1.0" standalone="no"'.'?>'."\n";
				$_svg .= '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">'."\n"; 
				$_svg .= '<svg width="100%" height="100%" version="1.1" xmlns="http://www.w3.org/2000/svg">'."\n";

				$_svg .=	'<line x1="10" y1="20"   x2="10"  y2="260" style="stroke: #000000; stroke-width:2;"/>'."\n";
			 	$_svg .=	'<line x1="10" y1="260"  x2="'.(X_WIDTH_SPECTRUM+10).'" y2="260" style="stroke: #000000; stroke-width:2;"/>'."\n";	
				

				$_x_scale = X_WIDTH_SPECTRUM / $_spectrums[0]['spectrum'][ sizeof( $_spectrums[0]['spectrum'] )-1 ]['y'];
				$_y_scale = 240/$_maxE;

				for( $h=0; $h<sizeof($_spectrums); $h++ )
				{
					$_svg .=  '<path d="'."\n";

					$_svg .=  'M'.(($_spectrums[$h]['spectrum'][0]['y']*$_x_scale)+10).','.( 260 - ($_spectrums[$h]['spectrum'][0]['e']*$_y_scale))."\n";

					for( $k=1; $k<sizeof( $_spectrums[$h]['spectrum'] ); $k++ )
					{
						$_svg .=    'L'.(($_spectrums[$h]['spectrum'][$k]['y']*$_x_scale)+10).','.( 260 - ($_spectrums[$h]['spectrum'][$k]['e']*$_y_scale))."\n";
						//$_svg .=    'L'.(($spectrum[$k]['y']*$_x_scale)+10).','.( 250 - (Model::getEFromPlanksEquations( $spectrum[$k]['y'], $Model->layers['s']->T )*$_y_scale))."\n";
					}

					$_svg .= '"'."\n";
		
					$_svg .= 'style="stroke: '.getColour( $h ).'; stroke-width:1; fill:none;"/>'."\n";
				}



				$_svg .= '<text x="10" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >0</text>'."\n";
				$_svg .= '<text x="'.((X_WIDTH_SPECTRUM/5)+8).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >20&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (20*$_x_scale)).'" y1="260"   x2="'.(10 + (20*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.((2*X_WIDTH_SPECTRUM/5)+6).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >40&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (40*$_x_scale)).'" y1="260"   x2="'.(10 + (40*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.((3*X_WIDTH_SPECTRUM/5)+14).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >60&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (60*$_x_scale)).'" y1="260"   x2="'.(10 + (60*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.((4*X_WIDTH_SPECTRUM/5)+2).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >80&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (80*$_x_scale)).'" y1="260"   x2="'.(10 + (80*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";
				$_svg .= '<text x="'.( X_WIDTH_SPECTRUM ).'" y="275" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >100&#181;m</text>'."\n";
				$_svg .= '<line x1="'.(10 + (100*$_x_scale)).'" y1="260"   x2="'.(10 + (100*$_x_scale)).'"  y2="264" style="stroke: #000000; stroke-width:2;"/>'."\n";

				$_svg .= '<text x="10" y="12" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >'.round($maxE,1).' W/m&#179;</text>'."\n";

				for( $h=0; $h<sizeof($_spectrums[$h]['spectrum']); $h++ )
				{

					$_svg .= '<line x1="10" y1="'.(285+($h*15)).'"   x2="40"  y2="'.(285+($h*15)).'" style="stroke: '.getColour( $h ).'; stroke-width:2;"/>'."\n";
					$_svg .= '<text x="50" y="'.(289+($h*15)).'" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >'.htmlentities($_spectrums[$h]['title']).'</text>'."\n";

				}

				$_svg .= '</svg>';

				file_put_contents( '../'.USER_SPACE.'/'.$user_id.'/radiation.svg', $_svg );


		}

		reset( $_user_status['run'] );
	}

	echo json_encode( array('success'=>1) );
}

if( $_GET['actiontype'] == 'startProject' )
{
	$user_id = "";

	for( $i=0; $i<10; $i++ )
	{
		$user_id .= rand( 0, 9 );
	}
	
	

	setcookie( 'user_id', $user_id, mktime() + 30*24*60*60, '/' );

	echo json_encode( array('success'=>1, 'cookie'=>$user_id ) );

}

if( $_GET['actiontype'] == 'getProject' )
{
	$user_id = trim($_GET['ID']);
	
	if ( strlen( $user_id ) && is_dir( '../'.USER_SPACE.'/'.$user_id ) )
	{

		setcookie( 'user_id', $user_id, mktime() + 30*24*60*60, '/' );
		echo json_encode( array('success'=>1, 'cookie'=>$user_id ) );

	}
	else
	{
		echo json_encode( array('success'=>0 ) );
	}	

}

if (  $_GET['actiontype'] == 'getEMCGraph' )
{
	define( X_WIDTH, 300 );
	define( _MARGIN, 40 );
	define( Y_HEIGHT, 300 );

	Header( "Content-type: image/svg+xml" );

	echo '<'.'?xml version="1.0" standalone="no"'.'?>';
?>  
        
        <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> 
	<svg width="100%" height="100%" version="1.1" xmlns="http://www.w3.org/2000/svg">

        <line x1="<?=_MARGIN?>" y1="<?=_MARGIN?>"   x2="<?=_MARGIN?>"  y2="<?=Y_HEIGHT+_MARGIN?>" style="stroke: #000000; stroke-width:2;"/>
 	<line x1="<?=_MARGIN?>" y1="<?=Y_HEIGHT+_MARGIN?>"  x2="<?=X_WIDTH+_MARGIN?>" y2="<?=Y_HEIGHT+_MARGIN?>" style="stroke: #000000; stroke-width:2;"/>
	
<?

	echo '<path d="M'. _MARGIN.','.(Y_HEIGHT+_MARGIN)."\n";

	$f = fopen(EMMESIVITY_CORRECTION_FILE, 'r' );

	while( $line = rtrim(fgets( $f, 1024 )) )
	{
		list( $a, $emc ) = explode( ',', $line );

		echo 'L'.( _MARGIN + $a*X_WIDTH).','.(Y_HEIGHT+_MARGIN - ($emc*Y_HEIGHT*2) )."\n";

	}

	echo 'L'.( _MARGIN + X_WIDTH).','._MARGIN.'"'."\n";
	echo 'style="stroke: #000000; stroke-width:1; fill:none;"/>';	
?>
	 <text x="<?=_MARGIN?>" y="<?=_MARGIN-15?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >Ce - Correction Factor</text>
         <text x="<?=_MARGIN-20?>" y="<?=_MARGIN+3?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >0.5</text>
         <text x="<?=X_WIDTH + _MARGIN + 7?>" y="<?=Y_HEIGHT + _MARGIN + 3?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >Absorptivity</text>
	 <text x="<?=X_WIDTH + _MARGIN - 5?>" y="<?=Y_HEIGHT + _MARGIN + 15?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >1.0</text>
	</svg>
<?

}

if (  $_GET['actiontype'] == 'getLayerDiagram' )
{
	define( X_WIDTH, 600 );
	define( _MARGIN, 60 );
	define( Y_HEIGHT, 600 );

	Header( "Content-type: image/svg+xml" );

	echo '<'.'?xml version="1.0" standalone="no"'.'?>';
?>  
        
        <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> 
	<svg width="100%" height="100%" version="1.1" xmlns="http://www.w3.org/2000/svg">

 	<line x1="<?=_MARGIN?>" y1="<?=Y_HEIGHT+_MARGIN?>"  x2="<?=X_WIDTH+_MARGIN?>" y2="<?=Y_HEIGHT+_MARGIN?>" style="stroke: #000000; stroke-width:2;"/>
	<text x="<?=X_WIDTH+_MARGIN+10?>" y="<?=Y_HEIGHT+_MARGIN+5?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >L(surface)</text>
	<text x="<?=_MARGIN-35?>" y="<?=Y_HEIGHT + _MARGIN?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >FL(0)</text>
<?	
	for( $i=1; $i<=10; $i++ )
	{	
?>
	<line x1="<?=_MARGIN?>" y1="<?=Y_HEIGHT+_MARGIN - ($i*Y_HEIGHT/10)?>"  x2="<?=X_WIDTH+_MARGIN?>" y2="<?=Y_HEIGHT+_MARGIN - ($i*Y_HEIGHT/10)?>" style="stroke: #000000; stroke-width:1;"/>	
	<text x="<?=X_WIDTH+_MARGIN+10?>" y="<?=Y_HEIGHT- ($i*Y_HEIGHT/10) + Y_HEIGHT/20 + _MARGIN+5?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >L(<?=$i?>) <?=((10-$i+1)/10 * TOTAL_ATMOSPHERE)?> - <?=((10-$i)/10 * TOTAL_ATMOSPHERE)?>hPa </text>
	<text x="<?=_MARGIN-35?>" y="<?=Y_HEIGHT- ($i*Y_HEIGHT/10) + _MARGIN?>" style="stroke:#000000; fill: #000000; font-family:Arial; font-size: 10px;" >FL(<?=$i?>)</text>

<?
	}

?>	 
	  <path d="M310,360
		C310,360 320,350 330,355
                C330,355 340,345 350,350
                C350,350 360,340 370,345
                C370,345 380,335 390,345
		C390,345 400,335 410,345
		C410,345 420,335 430,350
                C430,350 440,340 450,355
                C450,355 460,345 470,360
		C470,360 390,375 310,360" 
		style="stroke: #000000; stroke-width:2;fill: #FFFFFF"/>
 
         <path d="M<?=50+_MARGIN?>,<?=450+_MARGIN?>
		L<?=70+_MARGIN?>,<?=180+_MARGIN?>"
		style="stroke-dasharray: 9, 3; stroke: #000000; stroke-width:2;fill: none"/>
     
        <circle cx="<?=50+_MARGIN?>" cy="<?=450+_MARGIN?>" r="5" style="stroke: black; fill: none;"/> 
	<polygon
           points="<?=70+_MARGIN?>,<?=180+_MARGIN?>  <?=80+_MARGIN?>,<?=190+_MARGIN?>  <?=60+_MARGIN?>,<?=190+_MARGIN?>"
           style="fill: #ccffcc; stroke: #000000;"/>

	 <path d="M<?=50+_MARGIN?>,<?=450+_MARGIN?>
		L<?=120+_MARGIN?>,<?=Y_HEIGHT+_MARGIN?>"
		style="stroke-dasharray: 9, 3; stroke: #000000; stroke-width:2;fill: none"/>

	  <path d="M<?=120+_MARGIN?>,<?=Y_HEIGHT+_MARGIN?>
		L<?=270+_MARGIN?>,<?=180+_MARGIN?>"
		style="stroke-dasharray: 3, 3; stroke: #000000; stroke-width:2;fill: none"/>
          <polygon
           points="<?=270+_MARGIN?>,<?=180+_MARGIN?>  <?=270+_MARGIN-10?>,<?=180+_MARGIN+10?>  <?=270+_MARGIN+10?>,<?=180+_MARGIN+10?>"
           style="fill: #ccffcc; stroke: #000000;"/>

 	  <path d="M<?=50+_MARGIN?>,<?=450+_MARGIN?>
		L<?=180+_MARGIN?>,<?=Y_HEIGHT+_MARGIN?>"
		style="stroke-dasharray: 9, 3; stroke: #000000; stroke-width:2;fill: none"/>
	  <path d="M<?=180+_MARGIN?>,<?=Y_HEIGHT+_MARGIN?>
		L<?=330+_MARGIN?>,<?=310+_MARGIN?>"
		style="stroke-dasharray: 3, 3; stroke: #000000; stroke-width:2;fill: none"/>


	  <path d="M<?=330+_MARGIN?>,<?=310+_MARGIN?>
		L<?=400+_MARGIN?>,<?=180+_MARGIN?>"
		style="stroke-dasharray: 1, 8; stroke: #000000; stroke-width:2;fill: none"/>
	  <polygon
           points="<?=400+_MARGIN?>,<?=180+_MARGIN?>  <?=400+_MARGIN-10?>,<?=180+_MARGIN+10?>  <?=400+_MARGIN+10?>,<?=180+_MARGIN+10?>"
           style="fill: #ccffcc; stroke: #000000;"/>


	   <path d="M<?=330+_MARGIN?>,<?=310+_MARGIN?>
		L<?=480+_MARGIN?>,<?=Y_HEIGHT+_MARGIN?>"
		style="stroke-dasharray: 1, 4; stroke: #000000; stroke-width:2;fill: none"/>
	   <path d="M<?=480+_MARGIN?>,<?=Y_HEIGHT+_MARGIN?>
		L<?=570+_MARGIN?>,<?=180+_MARGIN?>"
		style="stroke-dasharray: 1, 8; stroke: #000000; stroke-width:2;fill: none"/>
	  
  	   <polygon
           points="<?=570+_MARGIN?>,<?=180+_MARGIN?>  <?=570+_MARGIN-10?>,<?=180+_MARGIN+10?>  <?=570+_MARGIN+10?>,<?=180+_MARGIN+10?>"
           style="fill: #ccffcc; stroke: #000000;"/>		  

	</svg>
<?
}

	
?>
